//遮罩蒙板

import { _decorator, Node, tween, Tween } from 'cc';
import { Framework } from '../../framework/Framework';
import { BaseView } from '../../framework/layer/BaseView';
import { FrameworkConf } from '../../framework/config/FrameworkConf';

const { ccclass, property } = _decorator;

@ccclass('MaskUI')
export class MaskUI extends BaseView {


	protected onLoad() {
		Framework.event.addEvent(FrameworkConf.Event.NET_HANDSHAKE_ERROR, this.onHandshakeError.bind(this),this);
	}

	protected onDestroy() {

	}

	//UI开打时会调用,如果有初始化代码应该放到此函数
	onOpen(data) {
		this.node.active = false
		this.Node.relogin.active = false
	}

	//UI关闭时会调用,该函数在onDestroy前调用
	onClose() {
		
	}

	//框架管理UI层级时会调用,可根据UI情况修改
	onShow() {
		super.onShow();
	}

	//框架管理UI层级时会调用,可根据UI情况修改
	onHide() {
		super.onHide();
	}

	onHandshakeError(code) {
		this.Node.bg.active = false
		this.Node.relogin.active = true
		this.unscheduleAllCallbacks()
		if(code == 4){
			this.Label.retext.string = "your account is logined on another devise"
			
		}
		else{
			this.Label.retext.string = "server closed"
		}
		
	}

	//返回登录
	onClick() {
		window.parent.postMessage(FrameworkConf.WebEvent.CLOSE, "*");
	}

}